using System;
using System.ComponentModel;
using System.Drawing;
using System.Linq;

namespace PowerLanguage.Strategy
{
	public abstract class DefaultValueSignalObject : SignalObject
	{
        public DefaultValueSignalObject(object ctx) : base(ctx) {
			
		    foreach (PropertyDescriptor prop in TypeDescriptor.GetProperties(this)) {
		        DefaultValueInputAttribute attr = (DefaultValueInputAttribute)prop.Attributes[typeof(DefaultValueInputAttribute)];
		        if (attr != null) {
		            prop.SetValue(this, attr.value);
		        }
			}
		}
	}
}