using System;
using PowerLanguage.Function;

namespace PowerLanguage.Strategy
{
    public class MovAvg_Cross_LE : SignalObject
    {
        private ISeries<Double> m_price;

        private int m_length = 9;

        private double m_confirmbars = 1;

        private AverageFC m_averagefc1;

        private VariableObject<Int32> m_counterl;

        private double m_avg;

        private IOrderMarket m_Order0;

        public MovAvg_Cross_LE(object ctx) :
            base(ctx) {}

        private ISeries<Double> price{
            get { return m_price; }
        }

        [Input]
        public int length{
            get { return m_length; }
            set { m_length = value; }
        }

        [Input]
        public double confirmbars{
            get { return m_confirmbars; }
            set { m_confirmbars = value; }
        }

        protected override void Create(){
            m_averagefc1 = new AverageFC(this);
            m_counterl = new VariableObject<Int32>(this);
            m_Order0 =
                OrderCreator.MarketNextBar(new SOrderParameters(Contracts.Default, "MACrossLE", EOrderAction.Buy));
        }

        protected override void StartCalc(){
            m_price = Bars.Close;
            m_averagefc1.price = price;
            m_averagefc1.length = new Lambda<Int32>(delegate { return length; });
            m_counterl.DefaultValue = 0;
            m_avg = 0;
        }


        protected override void CalcBar(){
            m_avg = m_averagefc1[0];
            if (PublicFunctions.DoubleGreater(price[0], m_avg)){
                m_counterl.Value = (m_counterl.Value + 1);
            }
            else{
                m_counterl.Value = 0;
            }
            if ((PublicFunctions.DoubleGreater(Bars.CurrentBar, confirmbars)
                 && (m_counterl.Value == confirmbars))){
                m_Order0.Send();
            }
        }
    }
}