using System;
using PowerLanguage.Function;
using System.ComponentModel;

namespace PowerLanguage.Strategy
{
    public class MovAvg_Cross_LE_Rev : DefaultValueSignalObject
    {
        private AverageFC 				m_averagefc1;
        private VariableObject<Int32>	m_counterl;
        private double 					m_avg;
        private IOrderMarket 			m_Order0;

        public ISeries<Double> price{ get; set; }

        [DefaultValueInput(9)]
        public int length{ get; set; }

        [DefaultValueInput(1)]
        public double confirmbars{ get; set; }

		public MovAvg_Cross_LE_Rev(object ctx) : base(ctx) {}

        protected override void Create(){
            m_averagefc1 = new AverageFC(this);
            m_counterl = new VariableObject<Int32>(this);
            m_Order0 =
                OrderCreator.MarketNextBar(new SOrderParameters(Contracts.Default, "MACrossLE", EOrderAction.Buy));
        }

        protected override void StartCalc(){
            price = Bars.Close;
            m_averagefc1.price = price;
            m_averagefc1.length = new Lambda<Int32>(delegate { return length; });
            m_counterl.DefaultValue = 0;
            m_avg = 0;
        }


        protected override void CalcBar(){
            m_avg = m_averagefc1[0];
            if (PublicFunctions.DoubleGreater(price[0], m_avg)){
                m_counterl.Value = (m_counterl.Value + 1);
            }
            else{
                m_counterl.Value = 0;
            }
            if ((PublicFunctions.DoubleGreater(Bars.CurrentBar, confirmbars)
                 && (m_counterl.Value == confirmbars))){
                m_Order0.Send();
            }
        }
    }
}